# Contributing

Contributing is an essential part of open source projects like Bedrock Launcher; hence it is necessary to maintain strict rules and a high standard.

## Soft Floor Code Regulations
*Things that you are supposed to do, however it's okay not to*
- Avoid renaming files unless it is a naming style parity
- Keep your commits well named and low in numbers (it's easier for us to review)

## Hard Floor Code Regulations
*Things that cannot be ignored at any cost*
- Abide to the [code of conduct](./CODE_OF_CONDUCT.md)
- Maintain the folder structure at the root directory
- Do not make changes that moves the launcher away from parity with the official Java launcher
- Do not leave builds in the commit

## Prerequisites
Make sure you meet both the [hardware prerequisites](./HARDWARE_PREREQUISITES.md) and [software prerequisites](./SOFTWARE_PREREQUISITES.md) to avoid introducing random environmental variables.

## GitHub interactions
- Your interactions on GitHub should be civil, well worded, and clear
- Your proposed changes should be the means of pull requests
